/**
 *#########################################################################
 *
 * A component of the Gatherer application, part of the Greenstone digital
 * library suite from the New Zealand Digital Library Project at the
 * University of Waikato, New Zealand.
 *
 * <BR><BR>
 *
 * Author: John Thompson, Greenstone Digital Library, University of Waikato
 *
 * <BR><BR>
 *
 * Copyright (C) 1999 New Zealand Digital Library Project
 *
 * <BR><BR>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * <BR><BR>
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * <BR><BR>
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *########################################################################
 */

 




package org.greenstone.gatherer.gui;
import java.lang.Runnable;
import javax.swing.JLabel;
import javax.swing.SwingUtilities;
/** Just like a JLabel, except the text shown is updated using an overwriting runnable so that updates will only occur when process load is moderate. This functionality is currently disabled as it was somehow taking 5% of copy time, and not doing what it was supposed to anyway (the same event apparently can be added to the event queue over and over). */
public class SmudgyLabel 
    extends JLabel {
    private SmudgyUpdate update = null;
    public SmudgyLabel(String text) {
	super(text);
    }
    public void setText(String text) {
	super.setText(text);
	/*
	  if(update == null) {
	  update = new SmudgyUpdate(text);
	  }
	  else {
	  update.setText(text);
	  }
	  SwingUtilities.invokeLater(update);
	*/
    }
    public void setTextImmediately(String text) {
	super.setText(text);
    }
    private class SmudgyUpdate
	implements Runnable {
	private String text = null;
	public SmudgyUpdate(String text) {
	    this.text = text;
	}
	public void run() {
	    setTextImmediately(text);
	}
	public void setText(String text) {
	    this.text = text;
	}
    }

}
